﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;

namespace GenericAggregatesWPF
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			List<Person> persons = new List<Person>();
			persons.Add(new Person() { Name = "Person1", Sex = Gender.Female });
			persons.Add(new Person() { Name = "Person2", Sex = Gender.Female });
			persons.Add(new Person() { Name = "Person3", Sex = Gender.Male });
			persons.Add(new Person() { Name = "Person4", Sex = Gender.Female });
			persons.Add(new Person() { Name = "Person5", Sex = Gender.Male });
			persons.Add(new Person() { Name = "Person6", Sex = Gender.Female });

			this.RadGridView1.ItemsSource = persons;
			var femalesCountFunction = new AggregateFunction<Person,int>();

			femalesCountFunction.AggregationExpression = prsns => prsns.Where(p => p.Sex == Gender.Female).Count();
			femalesCountFunction.Caption = "Females count:";

			this.RadGridView1.Columns[0].AggregateFunctions.Add(femalesCountFunction);
		}
	}

	public enum Gender { Male, Female };
 

	public class Person
	{
		public string Name { get; set; }
		public Gender Sex { get; set; }
	}
 
}
